package ebs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RemoveDiskReplicaPair invokes the ebs.RemoveDiskReplicaPair API synchronously
func (client *Client) RemoveDiskReplicaPair(request *RemoveDiskReplicaPairRequest) (response *RemoveDiskReplicaPairResponse, err error) {
	response = CreateRemoveDiskReplicaPairResponse()
	err = client.DoAction(request, response)
	return
}

// RemoveDiskReplicaPairWithChan invokes the ebs.RemoveDiskReplicaPair API asynchronously
func (client *Client) RemoveDiskReplicaPairWithChan(request *RemoveDiskReplicaPairRequest) (<-chan *RemoveDiskReplicaPairResponse, <-chan error) {
	responseChan := make(chan *RemoveDiskReplicaPairResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RemoveDiskReplicaPair(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RemoveDiskReplicaPairWithCallback invokes the ebs.RemoveDiskReplicaPair API asynchronously
func (client *Client) RemoveDiskReplicaPairWithCallback(request *RemoveDiskReplicaPairRequest, callback func(response *RemoveDiskReplicaPairResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RemoveDiskReplicaPairResponse
		var err error
		defer close(result)
		response, err = client.RemoveDiskReplicaPair(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RemoveDiskReplicaPairRequest is the request struct for api RemoveDiskReplicaPair
type RemoveDiskReplicaPairRequest struct {
	*requests.RpcRequest
	ClientToken    string `position:"Query" name:"ClientToken"`
	ReplicaGroupId string `position:"Query" name:"ReplicaGroupId"`
	ReplicaPairId  string `position:"Query" name:"ReplicaPairId"`
}

// RemoveDiskReplicaPairResponse is the response struct for api RemoveDiskReplicaPair
type RemoveDiskReplicaPairResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateRemoveDiskReplicaPairRequest creates a request to invoke RemoveDiskReplicaPair API
func CreateRemoveDiskReplicaPairRequest() (request *RemoveDiskReplicaPairRequest) {
	request = &RemoveDiskReplicaPairRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ebs", "2021-07-30", "RemoveDiskReplicaPair", "ebs", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRemoveDiskReplicaPairResponse creates a response to parse from RemoveDiskReplicaPair response
func CreateRemoveDiskReplicaPairResponse() (response *RemoveDiskReplicaPairResponse) {
	response = &RemoveDiskReplicaPairResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
