package ens

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RetryWorkflow invokes the ens.RetryWorkflow API synchronously
func (client *Client) RetryWorkflow(request *RetryWorkflowRequest) (response *RetryWorkflowResponse, err error) {
	response = CreateRetryWorkflowResponse()
	err = client.DoAction(request, response)
	return
}

// RetryWorkflowWithChan invokes the ens.RetryWorkflow API asynchronously
func (client *Client) RetryWorkflowWithChan(request *RetryWorkflowRequest) (<-chan *RetryWorkflowResponse, <-chan error) {
	responseChan := make(chan *RetryWorkflowResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RetryWorkflow(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RetryWorkflowWithCallback invokes the ens.RetryWorkflow API asynchronously
func (client *Client) RetryWorkflowWithCallback(request *RetryWorkflowRequest, callback func(response *RetryWorkflowResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RetryWorkflowResponse
		var err error
		defer close(result)
		response, err = client.RetryWorkflow(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RetryWorkflowRequest is the request struct for api RetryWorkflow
type RetryWorkflowRequest struct {
	*requests.RpcRequest
	WorkflowIds *[]string `position:"Query" name:"WorkflowIds"  type:"Json"`
}

// RetryWorkflowResponse is the response struct for api RetryWorkflow
type RetryWorkflowResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateRetryWorkflowRequest creates a request to invoke RetryWorkflow API
func CreateRetryWorkflowRequest() (request *RetryWorkflowRequest) {
	request = &RetryWorkflowRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Ens", "2017-11-10", "RetryWorkflow", "ens", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRetryWorkflowResponse creates a response to parse from RetryWorkflow response
func CreateRetryWorkflowResponse() (response *RetryWorkflowResponse) {
	response = &RetryWorkflowResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
