package linkvisual

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryDeviceEvent invokes the linkvisual.QueryDeviceEvent API synchronously
func (client *Client) QueryDeviceEvent(request *QueryDeviceEventRequest) (response *QueryDeviceEventResponse, err error) {
	response = CreateQueryDeviceEventResponse()
	err = client.DoAction(request, response)
	return
}

// QueryDeviceEventWithChan invokes the linkvisual.QueryDeviceEvent API asynchronously
func (client *Client) QueryDeviceEventWithChan(request *QueryDeviceEventRequest) (<-chan *QueryDeviceEventResponse, <-chan error) {
	responseChan := make(chan *QueryDeviceEventResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryDeviceEvent(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryDeviceEventWithCallback invokes the linkvisual.QueryDeviceEvent API asynchronously
func (client *Client) QueryDeviceEventWithCallback(request *QueryDeviceEventRequest, callback func(response *QueryDeviceEventResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryDeviceEventResponse
		var err error
		defer close(result)
		response, err = client.QueryDeviceEvent(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryDeviceEventRequest is the request struct for api QueryDeviceEvent
type QueryDeviceEventRequest struct {
	*requests.RpcRequest
	IotId         string           `position:"Query" name:"IotId"`
	IotInstanceId string           `position:"Query" name:"IotInstanceId"`
	PageSize      requests.Integer `position:"Query" name:"PageSize"`
	EndTime       requests.Integer `position:"Query" name:"EndTime"`
	BeginTime     requests.Integer `position:"Query" name:"BeginTime"`
	CurrentPage   requests.Integer `position:"Query" name:"CurrentPage"`
	ProductKey    string           `position:"Query" name:"ProductKey"`
	ApiProduct    string           `position:"Body" name:"ApiProduct"`
	ApiRevision   string           `position:"Body" name:"ApiRevision"`
	DeviceName    string           `position:"Query" name:"DeviceName"`
	EventType     requests.Integer `position:"Query" name:"EventType"`
}

// QueryDeviceEventResponse is the response struct for api QueryDeviceEvent
type QueryDeviceEventResponse struct {
	*responses.BaseResponse
	Code         string `json:"Code" xml:"Code"`
	RequestId    string `json:"RequestId" xml:"RequestId"`
	ErrorMessage string `json:"ErrorMessage" xml:"ErrorMessage"`
	Success      bool   `json:"Success" xml:"Success"`
	Data         Data   `json:"Data" xml:"Data"`
}

// CreateQueryDeviceEventRequest creates a request to invoke QueryDeviceEvent API
func CreateQueryDeviceEventRequest() (request *QueryDeviceEventRequest) {
	request = &QueryDeviceEventRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Linkvisual", "2018-01-20", "QueryDeviceEvent", "Linkvisual", "openAPI")
	request.Method = requests.POST
	return
}

// CreateQueryDeviceEventResponse creates a response to parse from QueryDeviceEvent response
func CreateQueryDeviceEventResponse() (response *QueryDeviceEventResponse) {
	response = &QueryDeviceEventResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
