package paifeaturestore

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ChangeProjectFeatureEntityHotIdVersion invokes the paifeaturestore.ChangeProjectFeatureEntityHotIdVersion API synchronously
func (client *Client) ChangeProjectFeatureEntityHotIdVersion(request *ChangeProjectFeatureEntityHotIdVersionRequest) (response *ChangeProjectFeatureEntityHotIdVersionResponse, err error) {
	response = CreateChangeProjectFeatureEntityHotIdVersionResponse()
	err = client.DoAction(request, response)
	return
}

// ChangeProjectFeatureEntityHotIdVersionWithChan invokes the paifeaturestore.ChangeProjectFeatureEntityHotIdVersion API asynchronously
func (client *Client) ChangeProjectFeatureEntityHotIdVersionWithChan(request *ChangeProjectFeatureEntityHotIdVersionRequest) (<-chan *ChangeProjectFeatureEntityHotIdVersionResponse, <-chan error) {
	responseChan := make(chan *ChangeProjectFeatureEntityHotIdVersionResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ChangeProjectFeatureEntityHotIdVersion(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ChangeProjectFeatureEntityHotIdVersionWithCallback invokes the paifeaturestore.ChangeProjectFeatureEntityHotIdVersion API asynchronously
func (client *Client) ChangeProjectFeatureEntityHotIdVersionWithCallback(request *ChangeProjectFeatureEntityHotIdVersionRequest, callback func(response *ChangeProjectFeatureEntityHotIdVersionResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ChangeProjectFeatureEntityHotIdVersionResponse
		var err error
		defer close(result)
		response, err = client.ChangeProjectFeatureEntityHotIdVersion(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ChangeProjectFeatureEntityHotIdVersionRequest is the request struct for api ChangeProjectFeatureEntityHotIdVersion
type ChangeProjectFeatureEntityHotIdVersionRequest struct {
	*requests.RoaRequest
	Body              string `position:"Body" name:"body"`
	InstanceId        string `position:"Path" name:"InstanceId"`
	FeatureEntityName string `position:"Path" name:"FeatureEntityName"`
	ProjectId         string `position:"Path" name:"ProjectId"`
}

// ChangeProjectFeatureEntityHotIdVersionResponse is the response struct for api ChangeProjectFeatureEntityHotIdVersion
type ChangeProjectFeatureEntityHotIdVersionResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateChangeProjectFeatureEntityHotIdVersionRequest creates a request to invoke ChangeProjectFeatureEntityHotIdVersion API
func CreateChangeProjectFeatureEntityHotIdVersionRequest() (request *ChangeProjectFeatureEntityHotIdVersionRequest) {
	request = &ChangeProjectFeatureEntityHotIdVersionRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("PaiFeatureStore", "2023-06-21", "ChangeProjectFeatureEntityHotIdVersion", "/api/v1/instances/[InstanceId]/projects/[ProjectId]/featureentities/[FeatureEntityName]/action/changehotidversion", "", "")
	request.Method = requests.POST
	return
}

// CreateChangeProjectFeatureEntityHotIdVersionResponse creates a response to parse from ChangeProjectFeatureEntityHotIdVersion response
func CreateChangeProjectFeatureEntityHotIdVersionResponse() (response *ChangeProjectFeatureEntityHotIdVersionResponse) {
	response = &ChangeProjectFeatureEntityHotIdVersionResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
