package paifeaturestore

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListProjectFeatureViewOwners invokes the paifeaturestore.ListProjectFeatureViewOwners API synchronously
func (client *Client) ListProjectFeatureViewOwners(request *ListProjectFeatureViewOwnersRequest) (response *ListProjectFeatureViewOwnersResponse, err error) {
	response = CreateListProjectFeatureViewOwnersResponse()
	err = client.DoAction(request, response)
	return
}

// ListProjectFeatureViewOwnersWithChan invokes the paifeaturestore.ListProjectFeatureViewOwners API asynchronously
func (client *Client) ListProjectFeatureViewOwnersWithChan(request *ListProjectFeatureViewOwnersRequest) (<-chan *ListProjectFeatureViewOwnersResponse, <-chan error) {
	responseChan := make(chan *ListProjectFeatureViewOwnersResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListProjectFeatureViewOwners(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListProjectFeatureViewOwnersWithCallback invokes the paifeaturestore.ListProjectFeatureViewOwners API asynchronously
func (client *Client) ListProjectFeatureViewOwnersWithCallback(request *ListProjectFeatureViewOwnersRequest, callback func(response *ListProjectFeatureViewOwnersResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListProjectFeatureViewOwnersResponse
		var err error
		defer close(result)
		response, err = client.ListProjectFeatureViewOwners(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListProjectFeatureViewOwnersRequest is the request struct for api ListProjectFeatureViewOwners
type ListProjectFeatureViewOwnersRequest struct {
	*requests.RoaRequest
	InstanceId string `position:"Path" name:"InstanceId"`
	ProjectId  string `position:"Path" name:"ProjectId"`
}

// ListProjectFeatureViewOwnersResponse is the response struct for api ListProjectFeatureViewOwners
type ListProjectFeatureViewOwnersResponse struct {
	*responses.BaseResponse
	RequestId string   `json:"RequestId" xml:"RequestId"`
	Owners    []string `json:"Owners" xml:"Owners"`
}

// CreateListProjectFeatureViewOwnersRequest creates a request to invoke ListProjectFeatureViewOwners API
func CreateListProjectFeatureViewOwnersRequest() (request *ListProjectFeatureViewOwnersRequest) {
	request = &ListProjectFeatureViewOwnersRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("PaiFeatureStore", "2023-06-21", "ListProjectFeatureViewOwners", "/api/v1/instances/[InstanceId]/projects/[ProjectId]/featureviewowners", "", "")
	request.Method = requests.GET
	return
}

// CreateListProjectFeatureViewOwnersResponse creates a response to parse from ListProjectFeatureViewOwners response
func CreateListProjectFeatureViewOwnersResponse() (response *ListProjectFeatureViewOwnersResponse) {
	response = &ListProjectFeatureViewOwnersResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
